using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Utils.DataBase;
using PhoenixUserManager.Class;

namespace PhoenixUserManager.GUI
{
    /// <summary>
    /// Search a user in the database on his mail
    /// </summary>
    public partial class fr_SearchUser : Form
    {
        #region Variables
        /// <summary>
        /// Software name to set in the Registry
        /// </summary>
        private string vSoftware = "";
        #endregion

        #region Constructor
        /// <summary>
        /// Constructor
        /// </summary>
        public fr_SearchUser()
        {
            InitializeComponent();
        }
        #endregion

        #region Events
        /// <summary>
        /// Click on search
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Click_SeekUser(object sender, EventArgs e)
        {
            SeekOnDb();
        }
        /// <summary>
        /// Key pressed on TextBox
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void KeyUp_TextBox(object sender, KeyEventArgs e)
        {
            if (e.KeyData == Keys.Enter)
                SeekOnDb();
        }
        /// <summary>
        /// Double click on the Dgv
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void DoubleClick_Dgv(object sender, EventArgs e)
        {
            try
            {
                if (dgv_User.Rows.Count <= 0) return;
                if (dgv_User.SelectedRows.Count <= 0) return;

                string _Name = (string)dgv_User.SelectedRows[0].Cells["Name"].Value
                    + " " + (string)dgv_User.SelectedRows[0].Cells["Surname"].Value
                    + " n le " + ((DateTime)dgv_User.SelectedRows[0].Cells["DateOfBirth"].Value).ToShortDateString();
                DialogResult dr = DialogResult.No;

                dr = MessageBox.Show("Etes vous bien " + _Name + "?\r\nDoit-on continuer l'activation?", "Question",
                    MessageBoxButtons.YesNo, MessageBoxIcon.Question);
                if (dr == DialogResult.No) return;

                int _Value = (int)dgv_User.SelectedRows[0].Cells["ID"].Value;
                UserManager.SetInRegistry(_Value, this.vSoftware);

                UserManager um = new UserManager("PhoenixUserManag", "", "jibedoubleve.mine.nu", "Phoenix", "Phoenix");
                int id = um.GetIDInRegistry();
                this.Close();
            }
            catch (Exception ex)
            {
                MessageBox.Show("Une erreur est intervenue (" + ex.Message + ")", "Erreur",
                    MessageBoxButtons.OK, MessageBoxIcon.Asterisk);
            }
        }
        #endregion

        #region Methods
        /// <summary>
        /// Displays the DataGridView
        /// </summary>
        protected void SetDgv()
        {
            this.dgv_User.Columns["ID"].Visible = false;
            this.dgv_User.Columns["Reasons"].Visible = false;

            this.dgv_User.Columns["Surname"].HeaderText = "Nom";
            this.dgv_User.Columns["Surname"].DisplayIndex = 0;

            this.dgv_User.Columns["Name"].HeaderText = "Prnom";
            this.dgv_User.Columns["Name"].DisplayIndex = 1;

            this.dgv_User.Columns["DateOfBirth"].HeaderText = "Date de naissance";
            this.dgv_User.Columns["DateOfBirth"].DisplayIndex = 2;

            this.dgv_User.Columns["DateInstall"].HeaderText = "Date d'inscription";
            this.dgv_User.Columns["DateInstall"].DisplayIndex = 3;
        }
        /// <summary>
        /// Seek the patient
        /// </summary>
        private void SeekOnDb()
        {
            try
            {
                string Mail = tb_Mail.Text.Replace("\"", "");
                tspb_ProgressBar.Style = ProgressBarStyle.Marquee;
                MySQLDbSql SqlManager = new MySQLDbSql("PhoenixUserManag", "", "jibedoubleve.mine.nu", "Phoenix");
                SqlManager.SqlQuery = "SELECT * FROM User WHERE Mail = \"" + Mail + "\";";
                DataSet ds = new DataSet();
                SqlManager.ExecuteSql(ref ds);
                dgv_User.DataSource = ds.Tables[0];

                SetDgv();
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            finally { tspb_ProgressBar.Style = ProgressBarStyle.Blocks; }
        }
        #endregion

        #region Properties
        /// <summary>
        /// Gets or sets the Registry name of the Key
        /// </summary>
        public string Software
        {
            get { return vSoftware; }
            set { vSoftware = value; }
        }
        #endregion
    }
}